import requests
import DISNET.Exceptions as E
from abc import ABC


class ServiceDisnet(ABC):
    """Parent class for the different services in the different layers of the API.
    It is an abstract class
    """

    def __init__(self):
        pass

    def connection(self, url: str) -> dict:
        """Method to make the connection to the specified url, it returns the response in a Json format.

        :param url: the specified url to make the get requests to.
        :raises NoResultFoundException: when the response code is not 200 or when the data set is empty.
        """
        urlMod = url.replace(' ', '%20')
        response = requests.get(urlMod)
        responseJson = response.json()
        if (response.status_code == 200 and responseJson["data"]):
            return responseJson
        else:
            raise E.NoResultFoundException()
